package bbs;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import dao.BoardCrud;

/**
 * Servlet implementation class BoardDetailServlet
 */
@WebServlet("/boardDetail.do")
public class BoardDetailServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public BoardDetailServlet() {
        super();
        // TODO Auto-generated constructor stub
    }


	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		doGet(request, response);
	}
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String seq = request.getParameter("SEQ");
		BoardCrud dao = new BoardCrud();
		BoardDTO dto = dao.getBoard(Integer.parseInt(seq));
		request.setAttribute("DTO", dto);//조회결과를 HttpServletRequest에 저장
		RequestDispatcher r = request.getRequestDispatcher("index.jsp?BODY=boardDetail.jsp");
		//게시글 상세정보를 보여주는 JSP(boardDetail.jsp)로 전환
		r.forward(request, response);
	}
}
class BoardDetailDAO {
	Connection con; PreparedStatement pstmt; ResultSet rs; BoardDTO dto;
	String query="select id,title,content,to_char(write_date,'YYYY/MM/DD HH24:MI:SS') "
			+ "from free_board where title = ?";
	BoardDTO doIt(String title) {
		try {
			Class.forName(OracleXE11g.LIB);
			con = DriverManager.getConnection(OracleXE11g.NAME, "hr","hr");
			pstmt = con.prepareStatement(query);
			pstmt.setString(1, title);//첫번째 물음표에 제목을 넣는다.
			rs = pstmt.executeQuery();//select를 실행하고 결과를 ResultSet에 저장
			rs.next();//조회결과가 1건이므로 조회결과로 한 번 이동
			dto = new BoardDTO();//조회결과를 저장하기 위해 DTO를 생성
			dto.setWriter(rs.getString(1));//select 다음 첫번째 조회결과를 DTO의 writer에 저장
			dto.setTitle(rs.getString(2));//select 다음 두번째 조회결과를 DTO의 title에 저장
			dto.setContent(rs.getString(3));//select다음 세번째 조회결과를 DTO의 content에 저장
			dto.setWrite_date(rs.getString(4));//select다음 네번째 조회결과를 DTO의 write_date에저장
		}catch(Exception e) {
			System.out.println("제목과 일치하는 게시글 조회 중 문제발생!!");
		}finally {
			try { con.close(); }catch(Exception e) {}
		}
		return dto;
	}
}
















