package items;

import java.util.ArrayList;

import dao.CartCrud;

public class Cart {
	//변수(장바구니 주인, 상품 코드, 상품 갯수)
	public Cart(String id) { this.id = id; }//생성자
	private String id;//계정이 저장된다.
	private ArrayList<String> codeList = new ArrayList<String>();//상품번호 N개 저장될 ArrayList
	private ArrayList<Integer> numList = new ArrayList<Integer>();//상품갯수 N개 저장될 ArrayList
	
	public ArrayList<String> getCodeList(){ return codeList; }
	public ArrayList<Integer> getNumList(){ return numList; }
	//메서드(장바구니에 담는 메서드, 장바구니에서 삭제하는 메서드,장바구니에서 변경하는 메서드 
	public void deleteItem(String code) {
		for(int i=0; i < codeList.size(); i++) {
			if(codeList.get(i).equals(code)) {
				codeList.remove(i);//i번째 상품코드를 삭제한다.
				numList.remove(i);//i번째 상품갯수를 삭제한다.
				// 데이터베이스와 연동 시작 //
				CartCrud dao = new CartCrud();
				Cart_tbl dto = new Cart_tbl();
				dto.setId(id); dto.setCode(code);
				dao.deleteCart(dto);
				// 데이터베이스와 연동 끝//
				return;//메서드를 종료한다.
			}//장바구니의 상품코드와 삭제하려는 상품코드가 일치하는 경우
		}
	}//장바구니에서 상품을 삭제하는 메서드
	
	public void modifyItem(String code, Integer num) {
		//code에 있는 상품번호와 일치하는 상품번호를 codeList에서 찾는다.
		for(int i=0; i < codeList.size(); i++) {
			if(codeList.get(i).equals(code)) {
				numList.set(i, num);//i번째 상품의 갯수를 num에 있는 상품갯수로 변경한다.
				/// 데이터베이스와 연동 시작 ///
				CartCrud dao = new CartCrud();
				Cart_tbl dto = new Cart_tbl();
				dto.setId(id); dto.setCode(code); dto.setNum(num);
				dao.updateCart(dto);
				/// 데이터베이스와 연동 끝 ///
				return;//메서드 종료
			}//i번째 상품번호와 code에 있는 상품번호가 같은 경우
		}
		//해당 상품번호의 상품갯수를 num에 있는 갯수로 변경한다.
		
	}//장바구니에서 상품의 갯수를 수정하는 메서드
	
	public void addCart(String code, Integer num) {
		for(int i=0; i < codeList.size(); i++) {
			if(codeList.get(i).equals(code)) {//i번째 상품번호와 code에 있는 상품번호가 같은경우
				Integer quantity = numList.get(i);//i번째 상품의 갯수를 찾는다.
				int sum = quantity + num;//기존의 갯수 + num에 있는 갯수
				numList.set(i, sum);//i번째 상품의 갯수를 sum에 있는 갯수로 바꾼다.
				/// 데이터베이스와 연동 시작 ///
				CartCrud dao = new CartCrud();
				Cart_tbl dto = new Cart_tbl();
				dto.setId(id); dto.setCode(code); dto.setNum(sum);
				dao.updateCart(dto);
				/// 데이터베이스와 연동 끝 ///
				return;//메서드 종료
			}
		}//codeList안에 있는 모든 상품번호를 차례로 검사한다.
		codeList.add(code); numList.add(num);
		////데이터 베이스와 연동 시작////
		CartCrud dao = new CartCrud();
		Cart_tbl dto = new Cart_tbl();
		dto.setId(id); dto.setCode(code); dto.setNum(num);
		dao.addCart(dto);
		////데이터 베이스와 연동 끝////
	}//장바구니에 상품의 번호와 상품의 갯수를 저장하는 메서드
}//장바구니 역할의 클래스










